import { Controller, Get, Req, Res, Session } from '@nestjs/common';
import { Request, Response } from 'express';
import { SessionData } from 'express-session';
import { AppService } from './app.service';

@Controller()
export class AppController {
  constructor(private readonly appService: AppService) {}

  @Get()
  getHello(
    @Session() session: SessionData,
    @Res() res: Response,
    @Req() req: Request,
  ): Record<string, any> {
    if (!session.user) {
      res.redirect('/login');
      return;
    }

    res.render('index', { user: req.user });
  }
}
